//------------------------------------------------------------
//    dot
//------------------------------------------------------------
#include "dot.h"
#include "../../main.h"
#include <stdlib.h>
unsigned const int Dot_Width = 10;
unsigned const int Dot_Height = 10;
//-----------------------------------------------------------
//    constructor
//-----------------------------------------------------------
Dot::Dot()
{
	set_type(DOT);
	pos[0] = 0;
	pos[1] = 0;
	width = Dot_Width;
	height = Dot_Height;
}

Dot::Dot(int px, int py)
{
	set_type(DOT);
	pos[0] = px;
	pos[1] = py;
	width = Dot_Width;
	height = Dot_Height;
}

//------------------------------------------------------------
//    destructor
//------------------------------------------------------------
Dot::~Dot()
{
}

//------------------------------------------------------------
//    set_pos
//------------------------------------------------------------
void Dot::set_pos(int px, int py)
{
	pos[0] = px;
	pos[1] = py;
}

//------------------------------------------------------------
//    move
//------------------------------------------------------------
void Dot::move(int dx, int dy)
{
	pos[0] += dx;
	pos[1] += dy;
}

//------------------------------------------------------------
//    get_pos
//------------------------------------------------------------
void Dot::get_pos(int pos_1[2]) const
{
	pos_1[0] = pos[0];
	pos_1[1] = pos[1];
}

//------------------------------------------------------------
//    get_pos_x
//------------------------------------------------------------
int Dot::get_pos_x() const
{
	return pos[0];
}

//------------------------------------------------------------
//    get_pos_y
//------------------------------------------------------------
int Dot::get_pos_y() const
{
	return pos[1];
}

//------------------------------------------------------------
//    get_width
//------------------------------------------------------------
unsigned int Dot::get_width() const
{
	return width;
}

//------------------------------------------------------------
//    get_height
//------------------------------------------------------------
unsigned int Dot::get_height() const
{
	return height;
}

//------------------------------------------------------------
//    select
//------------------------------------------------------------
bool Dot::select(int px, int py) const
{
	int x1, y1;
	x1 = abs(px - pos[0]);
	y1 = abs(py - pos[1]);
	bool b1 = ((x1<=(width/2))&&(y1<=(height/2)));
	return b1;
}
