//------------------------------------------------------------
//    line.cpp
//------------------------------------------------------------
#include "shape.h"
#include "line.h"
#include "dot.h"
#include <GL/gl.h>
#include <GL/glu.h>
#include <math.h>
const unsigned int default_width = 2;
const unsigned int select_width = 4;
//-----------------------------------------------------------
//    constructor
//-----------------------------------------------------------
Line::Line()
{
	set_type(LINE);
	width = default_width;
}

Line::Line(Dot* da, Dot* db)
{
	dot_1 = da;
	dot_2 = db;
	set_type(LINE);
	width = default_width;
}

//------------------------------------------------------------
//    destructor
//------------------------------------------------------------
Line::~Line()
{
}

//------------------------------------------------------------
//    select
//------------------------------------------------------------
bool Line::select(int px, int py) const
{
	double v_1[2], v_2[2], c1, c2, c3, c4;
	double d1, wd, innp, outp, ld1;
	bool b1;
	int p1[2], p2[2];
	dot_1->get_pos(p1);
	dot_2->get_pos(p2);
	v_1[0] = double(p1[0] - p2[0]);
	v_1[1] = double(p1[1] - p2[1]);
	v_2[0] = double(px - p2[0]);
	v_2[1] = double(py - p2[1]);
	
	wd = double(select_width * select_width);
	ld1 = (v_1[0] * v_1[0] + v_1[1] * v_1[1]);
	innp = (v_1[0] * v_2[0] + v_1[1] * v_2[1]);
	outp = (v_1[0] * v_2[1] - v_1[1] * v_2[0]);
	if(ld1 < 1.0){
		d1 = v_2[0] * v_2[0] + v_2[1] * v_2[1];
		b1 = (d1 <= wd);
	}else{
		c1 = (outp * outp) / ld1;
		b1 = (c1 <= wd)&&(innp > 0)&&(innp <= ld1);
	}
	return b1;
}

//------------------------------------------------------------
//    
//------------------------------------------------------------
void Line::set_dots(Dot* da, Dot* db)
{
	dot_1 = da;
	dot_2 = db;
}

//------------------------------------------------------------
//    
//------------------------------------------------------------
Dot* Line::get_dot_1() const
{
	return dot_1;
}

//------------------------------------------------------------
//    
//------------------------------------------------------------
Dot* Line::get_dot_2() const
{
	return dot_2;
}

//------------------------------------------------------------
//    
//------------------------------------------------------------
unsigned int Line::get_width() const
{
	return width;
}
