//------------------------------------------------------------
//    poly_line
//------------------------------------------------------------
#include "line.h"
#include "poly_line.h"
#include "dot.h"
#include <iostream>
//-----------------------------------------------------------
//    constructor
//-----------------------------------------------------------
Poly_Line::Poly_Line(std::vector<Dot>& dts_1)
{
	int i1, dot_size, line_size;
	Dot d1;
	set_type(POLY_LINE);
	dot_size = dts_1.size();
	line_size = dot_size - 1;
	dots = dts_1;
	Line l1;
	lines.assign(line_size, l1);
	for(i1 = 0; i1 < line_size; i1++){
		lines[i1].set_dots(&(dots[i1]), &(dots[i1+1]));
	}
}

//------------------------------------------------------------
//    destructor
//------------------------------------------------------------
Poly_Line::~Poly_Line()
{
	
}

//------------------------------------------------------------
//    
//------------------------------------------------------------
unsigned int Poly_Line::get_dot_size() const
{
	return (dots.size());
}

//------------------------------------------------------------
//    
//------------------------------------------------------------
unsigned int Poly_Line::get_line_size() const
{
	return (lines.size());
}

//------------------------------------------------------------
//    
//------------------------------------------------------------
void Poly_Line::copy_dots(std::vector<Dot>& dts_1) const
{
	int i1, n1;
	Dot d1(0, 0);
	n1 = dots.size();
	dts_1.assign(n1, d1);
	for(i1 = 0; i1 < n1; i1++){
		dts_1[i1].set_pos(dots[i1].get_pos_x(), dots[i1].get_pos_y());
	}
}

//------------------------------------------------------------
//    
//------------------------------------------------------------
bool Poly_Line::select(int px, int py) const
{
	bool b1 = false;
	int dsz = dots.size(), lsz = lines.size(), i1;
	for(i1 = 0; i1 < dsz; i1++){
		b1 |= dots[i1].select(px, py);
	}
	/*
	for(i1 = 0; i1 < lsz; i1++){
		b1 |= lines[i1].select(px, py);
	}
	*/
	return b1;
}

//------------------------------------------------------------
//    
//------------------------------------------------------------
int Poly_Line::select_dot(int px, int py) const
{
	bool b1 = false;
	int dsz = dots.size(), lsz = lines.size(), i1;
	for(i1 = 0; i1 < dsz; i1++){
		b1 = dots[i1].select(px, py);
		if(b1) return i1;
	}
	return -1;
}

//------------------------------------------------------------
//    
//------------------------------------------------------------
int Poly_Line::select_line(int px, int py) const
{
	bool b1 = false;
	int lsz = lines.size(), i1, x1 = px, y1 = py;
	for(i1 = 0; i1 < lsz; i1++){
		b1 = lines[i1].select(x1, y1);
		if(b1) return i1;
	}
	return -1;
}

//------------------------------------------------------------
//    
//------------------------------------------------------------
void Poly_Line::move_dot(int dnum, int dx, int dy)
{
	if((dnum<0)||(dnum>=dots.size())) return;
	dots[dnum].move(dx, dy);
}

//------------------------------------------------------------
//    
//------------------------------------------------------------
void Poly_Line::insert_dot(int px, int py)
{
	int x1 = px, y1 = py;
	int i1, lnum = select_line(x1, y1), dsz = dots.size();
	if(lnum==-1) return;
	Dot d1(px, py);
	dots.insert((dots.begin() + lnum + 1), d1);
	Line l1;
	lines.push_back(l1);
	for(i1 = 0; i1 < dsz; i1++){
		lines[i1].set_dots(&(dots[i1]), &(dots[i1 + 1]));
	}
}

//------------------------------------------------------------
//    
//------------------------------------------------------------
const Dot* Poly_Line::dot(unsigned int ndt) const
{
	if(ndt>(dots.size()-1)) return 0;
	return &(dots[ndt]);
}

//------------------------------------------------------------
//    
//------------------------------------------------------------
const Line* Poly_Line::line(unsigned int nli) const
{
	if(nli>(lines.size()-1)) return 0;
	return &(lines[nli]);
}

//------------------------------------------------------------
//    
//------------------------------------------------------------
void Poly_Line::erase_dot(int ndot)
{
	int i1, dsz = dots.size();
	if((ndot>=0)&&(ndot<dsz)){
		dots.erase(dots.begin() + ndot);
		lines.pop_back();
	}
	for(i1 = 0; i1 < dsz-2; i1++){
		lines[i1].set_dots(&(dots[i1]), &(dots[i1 + 1]));
	}
}

