//------------------------------------------------------------
//    class Poly_Line
//------------------------------------------------------------
#ifndef __Poly_Line__
#define __Poly_Line__
#include "shape.h"
#include <vector>
class Dot;
class Line;

class Poly_Line : public Shape
{
public:
	Poly_Line(std::vector<Dot>& dts_1);
	~Poly_Line();
	void insert_dot(Dot* d_1);
	void change_line_type();
	unsigned int get_dot_size() const;
	unsigned int get_line_size() const;
	const Dot* dot(unsigned int ndt) const;
	const Line* line(unsigned int nli) const;
	void copy_dots(std::vector<Dot>& dts_1) const;
	bool select(int px, int py) const;
	int select_dot(int px, int py) const;
	int select_line(int px, int py) const;
	void move_dot(int dnum, int dx, int dy);
	void insert_dot(int px, int py);
	void erase_dot(int ndot);
private:
	std::vector<Dot> dots;
	std::vector<Line> lines;
};
#endif

