//------------------------------------------------------------
//    draw_shape.cpp
//------------------------------------------------------------
#include "draw_shape.h"
#include "../../m/shapemod/shape.h"
#include "../../m/shapemod/line.h"
#include "../../m/shapemod/poly_line.h"
#include "../../m/shapemod/dot.h"
#include "../../main.h"
#include <GL/gl.h>
#include <GL/glu.h>
//------------------------------------------------------------
//    Draw()
//------------------------------------------------------------
void Draw(const Line* line_1)
{
	double px1, px2, py1, py2;
	double wd = (double)line_1->get_width();
	px1 = (double)line_1->get_dot_1()->get_pos_x();
	py1 = (double)line_1->get_dot_1()->get_pos_y();
	px2 = (double)line_1->get_dot_2()->get_pos_x();
	py2 = (double)line_1->get_dot_2()->get_pos_y();
	glLineWidth(wd);
	glColor3d(0.0, 0.0, 0.0);
	glBegin(GL_LINE_STRIP);
	glVertex3d(px1, py1, -1.0);
	glVertex3d(px2, py2, -1.0);
	glEnd();
}

//------------------------------------------------------------
//    Draw()
//------------------------------------------------------------
void Draw(const Poly_Line* poly_1)
{
	int i1, n1 = 0;
	n1 = poly_1->get_dot_size();
	for(i1 = 0; i1 < n1 - 1; i1++){
		Draw(poly_1->line(i1));
	}
	for(i1 = 0; i1 < n1; i1++){
		Draw(poly_1->dot(i1));
	}
}

//------------------------------------------------------------
//    Draw()
//------------------------------------------------------------
void Draw(const Dot* dot_1)
{
	double w1 = (double)dot_1->get_width() * 0.5;
	double h1 = (double)dot_1->get_height() * 0.5;
	double px1 = (double)dot_1->get_pos_x();
	double py1 = (double)dot_1->get_pos_y();
	glColor3d(0.0, 0.0, 0.0);
	glLineWidth(1.0);
	glBegin(GL_LINE_LOOP);
	glVertex3d(px1 - w1, py1 - h1, -3.0);
	glVertex3d(px1 + w1, py1 - h1, -3.0);
	glVertex3d(px1 + w1, py1 + h1, -3.0);
	glVertex3d(px1 - w1, py1 + h1, -3.0);
	glEnd();
	glPointSize(1.0);
	glBegin(GL_POINTS);
	glVertex3d(px1 - w1, py1 - h1, -3.0);
	glVertex3d(px1 + w1, py1 - h1, -3.0);
	glVertex3d(px1 + w1, py1 + h1, -3.0);
	glVertex3d(px1 - w1, py1 + h1, -3.0);
	glEnd();
}
