//------------------------------------------------------------
//    myframe
//------------------------------------------------------------
#include "../main.h"
#include "myframe.h"
#include "myglcanvas.h"
#include "../m/shapemod/poly_line.h"
#include <string>
#include <wx/wx.h>
#include <wx/image.h>
//------------------------------------------------------------
//    constructor
//------------------------------------------------------------
myFrame::myFrame(wxWindow* parent, int id,
	const wxString& title, const wxPoint& pos,
	const wxSize& size, long style):
    wxFrame(parent, id, title, pos, size, style)
{
	slider_1 = new wxSlider(this, id_slider1, sound_vol,
		slider1_min, slider1_max,
		wxDefaultPosition, wxDefaultSize,
		wxSL_VERTICAL|wxSL_INVERSE);
	label_1 = new wxStaticText(this, wxID_ANY, wxT("Vol"));
	button_1 = new wxToggleButton(this, id_button, wxT("play"));
	text_ctrl_1 = new wxTextCtrl(this, id_textctrl,
		wxString::Format(wxT("%d %s"), sound_freq, wxT("Hz")), wxDefaultPosition,
		wxDefaultSize, wxTE_RIGHT|wxTE_READONLY);
	myglc_1 = new myGLCanvas(this, id_myglcanvas, wxDefaultPosition,
		wxDefaultSize, wxSIMPLE_BORDER, wxEmptyString);
	set_properties();
	do_layout();
}

//------------------------------------------------------------
//    set_properties
//------------------------------------------------------------
void myFrame::set_properties()
{
	SetTitle(wxT("waveform"));
	SetBackgroundColour(wxSystemSettings::GetColour(wxSYS_COLOUR_3DFACE));
	myglc_1->SetMinSize(wxSize(canvas_size[0]+2, canvas_size[1]+2));
	slider_1->SetMinSize(wxSize(-1, 180));
}

//------------------------------------------------------------
//    do_layout
//------------------------------------------------------------
void myFrame::do_layout()
{
	wxBoxSizer* sizer_1 = new wxBoxSizer(wxVERTICAL);
	wxBoxSizer* sizer_2 = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer* sizer_3 = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer* sizer_6 = new wxBoxSizer(wxVERTICAL);
	sizer_3->Add(myglc_1, 1, wxLEFT|wxRIGHT|wxTOP, 5);
	sizer_6->Add(slider_1, 0, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	sizer_6->Add(label_1, 0, wxALIGN_CENTER_HORIZONTAL, 0);
	sizer_3->Add(sizer_6, 0, wxLEFT|wxRIGHT|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 10);
	sizer_1->Add(sizer_3, 0, wxSHAPED, 0);
	sizer_2->Add(button_1, 0, wxALL, 10);
	sizer_2->Add(text_ctrl_1, 0, wxALL, 10);
	sizer_1->Add(sizer_2, 0, wxALIGN_RIGHT, 0);
	SetSizer(sizer_1);
	sizer_1->Fit(this);
	Layout();
}
//------------------------------------------------------------
//    set_poly_line
//------------------------------------------------------------
void myFrame::set_poly_line(Poly_Line* pl1)
{
	poly_line_1 = pl1;
	myglc_1->set_poly_line(pl1);
}

