//-----------------------------------------------------------
//    myGLCanvas
//-----------------------------------------------------------
#include "../main.h"
#include "myglcanvas.h"
#include "./draw_shape/draw_shape.h"
#include "../m/shapemod/shape.h"
#include "../m/shapemod/dot.h"
#include "../m/shapemod/line.h"
#include "../m/shapemod/poly_line.h"
#include <GL/gl.h>
#include <GL/glu.h>
//-----------------------------------------------------------
//    constructor
//-----------------------------------------------------------
myGLCanvas::myGLCanvas(wxWindow* parent, wxWindowID id, const wxPoint& pos,
	const wxSize& size, long style, const wxString& name):
    wxGLCanvas(parent, id, pos, size, style, name)
{
	initialized = false;
}

//-----------------------------------------------------------
//    destructor
//-----------------------------------------------------------
myGLCanvas::~myGLCanvas()
{
	
}
//-----------------------------------------------------------
//    
//-----------------------------------------------------------
void myGLCanvas::init()
{
	int w1, h1;
	double c1;
	GLfloat lightpos[] = {0.0, 0.0, 0.0, 0.0};
	GLfloat lightd[] = {1.0, 1.0, 1.0, 0.0};
	double cp[] =
		{0,
		 (double)canvas_size[0],
		 0,
		 (double)canvas_size[1]};
	glClearColor(1.0, 1.0, 1.0, 0.0);
	
	w1 = GetSize().GetWidth();
	h1 = GetSize().GetHeight();
	SetBackgroundColour(wxColour(255, 255, 255));
	glColorMaterial(GL_FRONT, GL_DIFFUSE);
	glEnable(GL_COLOR_MATERIAL);
	glEnable(GL_DEPTH_TEST);
	glViewport(0, 0, (GLsizei)w1, (GLsizei)h1);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(cp[0], cp[1], cp[2], cp[3],
		-100.0, 100.0);
	gluLookAt(0.0, 0.0, 1.0,
		0.0, 0.0, - 1.0,
		0.0, 1.0, 0.0);
	glMatrixMode(GL_MODELVIEW);
	glFlush();
}

//-----------------------------------------------------------
//    
//-----------------------------------------------------------
void myGLCanvas::render()
{
	wxPaintDC(this);
	this->SetCurrent();
	if(initialized==false){
		init();
		initialized = true;
	}
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	draw_grid();
	draw_shapes();
	this->SwapBuffers();
}

//-----------------------------------------------------------
//    
//-----------------------------------------------------------
void myGLCanvas::draw_shapes()
{
	Draw(poly_line_1);
	glFlush();
}

//-----------------------------------------------------------
//    
//-----------------------------------------------------------
void myGLCanvas::draw_grid()
{
	int i1;
	double x1, y1, x2, y2, dl;
	
	glLineWidth(1.0);
	glColor3d(0.0, 0.0, 1.0);
	glBegin(GL_LINES);
	dl = (double)canvas_size[0] / (double)grid_num1;
	y1 = 0.0;
	y2 = (double)(canvas_size[1]);
	x1 = dl;
	for(i1 = 0; i1 < grid_num1 - 1; i1++){
		glVertex3d(x1, y1, -10.0);
		glVertex3d(x1, y2, -10.0);
		x1 += dl;
	}
	dl = (double)canvas_size[1] / (double)grid_num2;
	x1 = 0.0;
	x2 = (double)(canvas_size[0]);
	y1 = dl;
	for(i1 = 0; i1 < grid_num2 - 1; i1++){
		glVertex3d(x1, y1, -10.0);
		glVertex3d(x2, y1, -10.0);
		y1 += dl;
	}
	glEnd();
	glFlush();
}


//-----------------------------------------------------------
//    
//-----------------------------------------------------------
void myGLCanvas::set_poly_line(Poly_Line* pl1)
{
	poly_line_1 = pl1;
}
